// Generated by CoffeeScript 1.11.0
(function() {
  var $, _, _coffee, _yaml, argv, coffee, gulp, include, lint, path, plumber, project, replace, task, uglify, using, watch, yaml;

  $ = require('./index');

  _ = $._;

  argv = require('minimist')(process.argv.slice(2));

  gulp = require('gulp');

  watch = require('gulp-watch');

  plumber = require('gulp-plumber');

  include = require('gulp-include');

  replace = require('gulp-replace');

  using = require('gulp-using');

  coffee = require('gulp-coffee');

  yaml = require('gulp-yaml');

  uglify = require('gulp-uglify');

  lint = require('gulp-coffeelint');

  process.on('uncaughtException', function(err) {
    return $.log(err.stack);
  });

  task = {};

  $.task = function(name, fn) {
    gulp.task(name, function() {
      $.info('base', "running at " + project.base);
      return task[name]();
    });
    return task[name] = fn;
  };

  project = {
    base: process.cwd()
  };

  project.name = project.base.replace(/.*\\|.*\//, '');

  path = {
    source: './source'
  };

  path.coffee = path.source + "/**/*.coffee";

  _coffee = function() {
    return coffee({
      map: true
    });
  };

  _yaml = function() {
    return yaml({
      safe: true
    });
  };

  $.task('watch', function() {
    var list;
    list = [path.source + "/script/index.coffee", path.source + "/script/include/**/*.coffee"];
    return watch(list, function() {
      return task.build();
    });
  });

  $.task('build', function() {
    var fn;
    fn = {};
    fn.coffee = function(cb) {
      return gulp.src(path.source + "/script/index.coffee").pipe(plumber()).pipe(using()).pipe(include()).pipe(_coffee()).pipe(uglify()).pipe(gulp.dest('./')).on('end', function() {
        return typeof cb === "function" ? cb() : void 0;
      });
    };
    return fn.coffee();
  });

  $.task('lint', function() {
    return gulp.src(['./gulpfile.coffee', './test.coffee', path.coffee]).pipe(plumber()).pipe(using()).pipe(lint()).pipe(lint.reporter());
  });

  $.task('prepare', function() {
    return gulp.src('./coffeelint.yml').pipe(plumber()).pipe(using()).pipe(_yaml()).pipe(gulp.dest('./'));
  });

  $.task('work', function() {
    return $.shell('gulp watch');
  });

  $.task('noop', function() {
    return null;
  });

  $.task('test', function() {
    return $.shell('node test.js');
  });

  $.task('set', function() {
    var fn, fs, ver;
    if (argv.version) {
      fs = require('fs');
      ver = argv.version;
      fn = {};
      fn["package"] = function(cb) {
        var src;
        src = 'package.json';
        return gulp.src(src).pipe(plumber()).pipe(using()).pipe(replace(/"version": "[\d\.]+"/, "\"version\": \"" + ver + "\"")).pipe(gulp.dest('')).on('end', function() {
          return typeof cb === "function" ? cb() : void 0;
        });
      };
      return fn["package"](function() {
        return fn.init(function() {
          return fn.test();
        });
      });
    }
  });

}).call(this);

//# sourceMappingURL=gulpfile.js.map
